import { ObservableLike } from "@reactive-js/observable";
import { OperatorLike } from "@reactive-js/pipe";
import { AsyncEnumeratorLike } from "./interfaces";
export declare const enum ReducerRequestType {
    Continue = 1,
    Done = 2
}
export interface ContinueRequestLike<TReq, TAcc> {
    readonly type: ReducerRequestType.Continue;
    readonly req: TReq;
    readonly acc: TAcc;
}
export interface DoneRequestLike<TAcc> {
    readonly type: ReducerRequestType.Done;
    readonly acc: TAcc;
}
export declare type ReducerRequest<TReq, TAcc> = ContinueRequestLike<TReq, TAcc> | DoneRequestLike<TAcc>;
export declare const consume: <TReq, T, TAcc>(reducer: (acc: TAcc, next: T) => ReducerRequest<TReq, TAcc>, initial: () => ReducerRequest<TReq, TAcc>) => OperatorLike<AsyncEnumeratorLike<TReq, T>, ObservableLike<TAcc>>;
export declare const consumeAsync: <TReq, T, TAcc>(reducer: (acc: TAcc, next: T) => ObservableLike<ReducerRequest<TReq, TAcc>>, initial: () => ReducerRequest<TReq, TAcc>) => OperatorLike<AsyncEnumeratorLike<TReq, T>, ObservableLike<TAcc>>;
