"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const observable_1 = require("@reactive-js/observable");
const pipe_1 = require("@reactive-js/pipe");
exports.sink = (dest) => src => {
    const onSubscribe = (subscriber) => {
        const destEnumerator = dest.enumerateAsync(subscriber);
        const srcEnumerator = src.enumerateAsync(subscriber);
        srcEnumerator.subscribe(destEnumerator);
        destEnumerator.subscribe(srcEnumerator);
        subscriber.add(destEnumerator).add(srcEnumerator);
        destEnumerator.add(subscriber);
    };
    return pipe_1.pipe(onSubscribe, observable_1.createObservable, observable_1.endWith(undefined));
};
//# sourceMappingURL=sink.js.map