import { fromIterable as fromIterableObs, map, using, onNotify, takeWhile, } from "@reactive-js/observable";
import { pipe } from "@reactive-js/pipe";
import { createAsyncEnumerable } from "./createAsyncEnumerable";
const createFactory = (obs) => (enumerator) => pipe(obs, onNotify(() => enumerator.move()), takeWhile(_ => enumerator.hasCurrent), map(_ => enumerator.current));
export const fromIterable = (iterable) => {
    const enumerable = fromIterableObs(iterable);
    const operator = (obs) => using(() => enumerable.enumerate(), createFactory(obs));
    return createAsyncEnumerable(operator);
};
//# sourceMappingURL=fromIterable.js.map