import { createObservable, endWith, } from "@reactive-js/observable";
import { pipe } from "@reactive-js/pipe";
export const sink = (dest) => src => {
    const onSubscribe = (subscriber) => {
        const destEnumerator = dest.enumerateAsync(subscriber);
        const srcEnumerator = src.enumerateAsync(subscriber);
        srcEnumerator.subscribe(destEnumerator);
        destEnumerator.subscribe(srcEnumerator);
        subscriber.add(destEnumerator).add(srcEnumerator);
        destEnumerator.add(subscriber);
    };
    return pipe(onSubscribe, createObservable, endWith(undefined));
};
//# sourceMappingURL=sink.js.map