import { EnumeratorLike } from "@reactive-js/enumerable";
import { AbstractDelegatingSubscriber, MulticastObservableLike, SubscriberLike, SafeSubscriberLike, ObservableOperatorLike } from "@reactive-js/observable";
import { SchedulerLike } from "@reactive-js/scheduler";
import { AsyncEnumerableLike, AsyncEnumeratorLike } from "./interfaces";
export declare class AsyncEnumeratorImpl<TReq, T> extends AbstractDelegatingSubscriber<TReq, TReq> implements AsyncEnumeratorLike<TReq, T> {
    private readonly observable;
    readonly isSynchronous = false;
    constructor(delegate: SafeSubscriberLike<TReq>, observable: MulticastObservableLike<T>);
    get subscriberCount(): number;
    notify(req: TReq): void;
    dispatch(req: TReq): void;
    enumerate(): EnumeratorLike<void, T>;
    subscribe(subscriber: SubscriberLike<T>): void;
}
export declare const createAsyncEnumerator: <TReq, TData>(op: ObservableOperatorLike<TReq, TData>, scheduler: SchedulerLike, replayCount?: number | undefined) => AsyncEnumeratorLike<TReq, TData>;
export declare class AsyncEnumerableImpl<TReq, TData> implements AsyncEnumerableLike<TReq, TData> {
    private readonly op;
    constructor(op: ObservableOperatorLike<TReq, TData>);
    enumerateAsync(scheduler: SchedulerLike, replayCount?: number): AsyncEnumeratorLike<TReq, TData>;
}
export declare const createAsyncEnumerable: <TReq, TData>(op: ObservableOperatorLike<TReq, TData>) => AsyncEnumerableLike<TReq, TData>;
//# sourceMappingURL=createAsyncEnumerable.d.ts.map